{% extends 'Soutenances/base.html' %}
{% load static %}
<link rel="stylesheet" href="{% static 'Soutenances/css/style.css' %}">

{% block title %} Détail de l'Evenement "{{ object.nom }}" {% endblock %}

{% block contenu %}

{% if user.groupe == "admin" or user.groupe == "professeurs" or user.classe == object.groupe.nom and user.groupe == "eleves" %}
<input id="idgr" value= {{ object.groupe.id }} style="display:none;"/>
<input id="dd" value= {{ object.date_debut }} style="display:none;"/>
<input id="df" value= {{ object.date_fin }} style="display:none;"/>
<input id="dureeS" value= {{ object.dureeSoutenances }} style="display:none;"/>
<input id="idEven" value= {{ object.id }} style="display:none;"/>

<section id="evenementDetail">
    <section id="infoEvent">
        <h3>Informations Evenement</h3>
        <ul class="list-group">
            <li class="list-group-item center">Du {{ object.date_debut }} au {{ object.date_fin }}</li>
            <li class="list-group-item">Enseignant : {{ object.enseignant }}</li>
            <li class="list-group-item">Groupe : {{ object.groupe }}</li>
            <li class="list-group-item">Durée des soutenances : {{ object.dureeSoutenances }}min</li>
            
        </ul>
    </section>
    <button class="btn btn-primary" id="generer">Générer des slots dans des salles disponibles à des heures disponibles</button>
    <button class="btn btn-primary" id="attribuer">Attribuer groupes</button>
    <ul class="list-group" id="ulGRoupe">
        
    </ul>
</section>

<script>
    function getCookie(name) {
          var cookieValue = null;
          if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
          for (var i = 0; i < cookies.length; i++) {
               var cookie = jQuery.trim(cookies[i]);
          // Does this cookie string begin with the name we want?
          if (cookie.substring(0, name.length + 1) == (name + '=')) {
            cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
              break;
             }
          }
      }
 return cookieValue;
}

$(document).ready(function () {
    function decoupage(listeDisponibilite, dureeSoutenance) {
        listeCreneau = [];
        for (indice in listeDisponibilite){
            creneau = listeDisponibilite[indice];
            dureeCreneau = (creneau[1] - creneau[0]) * 60;
            if ((dureeCreneau / dureeSoutenance) >0 ){
                nbrCreneauPossible = Math.trunc(dureeCreneau / dureeSoutenance);
                debut = creneau[0];
                fin = debut + (dureeSoutenance/60);

                deb1 =  Math.trunc(debut);
                deb2 = debut - deb1 ;
                if (deb2 != 0){
                    deb2 = deb2*60;
                    deb2 = Math.round(deb2);
                    affiDebut = deb1 + "h" + deb2;
                }
                else{
                    affiDebut = deb1 + "h";
                }

                fin1 =  Math.trunc(fin);
                fin2 = fin - fin1 ;
                if (fin2 != 0){
                    fin2 = fin2*60;
                    fin2 = Math.round(fin2);
                    affiFin = fin1 + "h" + fin2;
                }
                else{
                    affiFin = fin1 + "h";
                }


                listeCreneau.push([affiDebut,affiFin])
                i = 1
                while (i != nbrCreneauPossible){
                    debut = fin;
                    fin += (dureeSoutenance/60);
                    deb1 =  Math.trunc(debut);
                deb2 = debut - deb1 ;
                if (deb2 != 0){
                    deb2 = deb2*60;
                    deb2 = Math.round(deb2);
                    affiDebut = deb1 + "h" + deb2;
                }
                else{
                    affiDebut = deb1 + "h";
                }

                fin1 =  Math.trunc(fin);
                fin2 = fin - fin1 ;
                if (fin2 != 0){
                    fin2 = fin2*60;
                    fin2 = Math.round(fin2);
                    affiFin = fin1 + "h" + fin2;
                }
                else{
                    affiFin = fin1 + "h";
                }
                
                listeCreneau.push([affiDebut,affiFin])
                i+=1;
                }
            }

        }
        return(listeCreneau);
            
    }

    $( "#generer" ).click(function() {
        
        let listeJours = ["lundi","mardi","mercredi","jeudi","vendredi"];
        let dd = $("input#dd").val();
        let df = $("input#df").val();
        let i = listeJours.indexOf(dd);
        let ifin = listeJours.indexOf(df);

        let listeJoursSelect = [];
        listeJoursSelect.push(listeJours[i]);
        while (i != ifin) {
            i ++
            listeJoursSelect.push(listeJours[i]);
        }

        let dureeS = document.getElementById('dureeS').value;
        let idEven = document.getElementById('idEven').value;
        let dico = {}//{jour : {salle : [ [8,10], [10,11] ] }}
        let nbr = 0;
        $.getJSON( "{% static 'Soutenances/json/sallesDispo.json' %}", function( data ) {
            $.each( data, function( salle, dicoJour ) { //KEY salle, VAl : jour 
                $.each( dicoJour, function( jour, lisHeures ) {// KEY1 jour, VAL : heures
                    if (listeJoursSelect.includes(jour)){
                        liste = decoupage(lisHeures,dureeS);
                        for (elem of liste){
                            var csrftoken = getCookie('csrftoken');
                            
                            $.ajax({
                                url: '/soutenances/api/slots/',
                                type: 'POST',
                                dataType: 'json',
                                data: { csrfmiddlewaretoken : csrftoken,
                                date: jour,
                                heure_debut: elem[0]+"",
                                heure_fin: elem[1]+"",
                                salle: salle + "",
                                evenement: idEven
                                },
                                success: function (data, textStatus, xhr) {
                                    nbr+=1;
                                    
                                    
                                },
                                error: function (xhr, textStatus, errorThrown) {
                                    console.log('Error in Operation');
                                }
                            });
                        }
                        
                    }
                });
            });
        });
        
        document.getElementById('succes').appendChild(document.createTextNode(nbr +  " Slots ont été générés "));
    });

    $( "#attribuer" ).click(function() {
        let dureeS = document.getElementById('dureeS').value;
        let idEven = document.getElementById('idEven').value;
        $.ajax({
            url: '/soutenances/api/groupesSoutenances/',
            type: 'GET',
            dataType: 'json',
            success: function (data, textStatus, xhr) {
                $.each( data, function( key,val ) { //KEY salle, VAl : jour 
                    
                    if (val.evenement == idEven){

                        let li = document.createElement("li");
                        li.id= "li" + val.id;
                        li.className = "list-group-item";
                        let selectGroupe = document.createElement("select");
                        selectGroupe.id = "selectGroupe" + val.id;
                        let selectDate = document.createElement("select");
                        selectDate.id ="selectDate" + val.id;
                        let listeJours = ["lundi","mardi","mercredi","jeudi","vendredi"];
                        for (jour of listeJours){
                            let optionJour = document.createElement("option");
                            optionJour.id = "jour" + listeJours.indexOf(jour);
                            optionJour.text = jour;
                            selectDate.appendChild(optionJour);
                        }

                        let selectSAlles= document.createElement("select")
                        let listeSalles = ["i21","i22","i23","i24","i25"];
                        selectSAlles.id = "selectSAlles" + val.id;
                        for (salles of listeSalles){
                            let optionSalles = document.createElement("option");
                            optionSalles.id = "salle" + listeSalles.indexOf(salles);
                            optionSalles.text = salles;
                            selectSAlles.appendChild(optionSalles);
                        }
                        let inputHeureDebut = document.createElement("input");
                        inputHeureDebut.id = "input" + val.id;
                        inputHeureDebut.value="";
                        inputHeureDebut.placeholder="Heure de début (ex: 8h20)";

                        let buttonValid = document.createElement("button");
                        buttonValid.id = "button"+val.id ;
                        buttonValid.innerHTML = "Ajouter Slot";

                       
                        
                        $.ajax({
                            url: '/soutenances/api/groupesSoutenances/',
                            type: 'GET',
                            dataType: 'json',
                            success: function (data1, textStatus1, xhr1) {
                                $.each( data1, function( key1,val1 ) { //KEY salle, VAl : jour 
                                    if (val1.evenement==idEven){
                                        let option = document.createElement("option");
                                        option.value=val1.id;
                                        option.text = val1.nom;
                                        selectGroupe.appendChild(option);

                                    }
                                });
                            },
                            error: function (xhr, textStatus, errorThrown) {
                                console.log('Error in Operation');
                            }
                        });
                        
                        li.appendChild(selectGroupe);
                        li.appendChild(selectDate);
                        li.appendChild(selectSAlles);
                        li.appendChild(inputHeureDebut);
                        li.appendChild(buttonValid);
                        document.getElementById('ulGRoupe').appendChild(li);
                        $("#button"+val.id).click(function() {
                            let resSelectGroupe = $( "#selectGroupe"+val.id ).val();
                            let resselectDate = $( "#selectDate"+val.id ).val();
                            let resselectSAlles = $( "#selectSAlles"+val.id ).val();
                            let resinputHeureDebut = $( "#input"+val.id ).val();


                            if (resinputHeureDebut != null && resinputHeureDebut !=""){
                                let regex = /^([0-9]|0[0-9]|1[0-9]|2[0-3])h[0-5][0-9]$/;
                                if(!regex.test(resinputHeureDebut))
                                {
                                    document.getElementById("li"+val.id).appendChild(document.createTextNode("Heure début ne correspond pas au format"));
                                }
                                else
                                {
                                    
                                    let listeHeureDebut = resinputHeureDebut.split("h");// "8h25"
                                    
                                    
                                    let duree = dureeS / 60; // 25 --> 0.33
                                    
                                    let min = parseInt(listeHeureDebut[1]) /60; //25 /60
                                    let hour = parseInt(listeHeureDebut[0]); // 8 
                                    
                                    let heureDeb = hour + min; // 8,33
                                    let heureFin = heureDeb + duree; //8.66
                                    
                                    heureFin = "" + heureFin;
                                    
                                    listeHeureFin = heureFin.split("."); // 8 et 55
                                    let x = listeHeureFin[0];//'8'
                                    let y = listeHeureFin[1];//'55'
                                    y = parseInt(listeHeureFin[1]);//55
                                    y *= 60;
                                    let HeureFinFinal = x+ "h" + y;
                                    if (HeureFinFinal.length >= 7){
                                        HeureFinFinal = HeureFinFinal.slice(0, 5);
                                    }
                                    else if (HeureFinFinal.length == 6){
                                        HeureFinFinal = HeureFinFinal.slice(0, 4);
                                    }
                                    var csrftoken = getCookie('csrftoken');
                                    let idEvent = $( "#idEven").val();
                                    $.ajax({
                                        url: '/soutenances/api/slots/',
                                        type: 'POST',
                                        dataType: 'json',
                                        data: { csrfmiddlewaretoken : csrftoken,
                                        date: resselectDate,
                                        heure_debut: resinputHeureDebut,
                                        heure_fin: HeureFinFinal,
                                        salle: resselectSAlles,
                                        evenement: idEvent
                                        },
                                        success: function (data, textStatus, xhr) {

                                        },
                                        error: function (xhr, textStatus, errorThrown) {
                                            console.log('Error in Operation');
                                        }
                                    });

                                    let maxSlot = 0;
                                    $.ajax({
                                        url: '/soutenances/api/slots/',
                                        type: 'GET',
                                        dataType: 'json',
                                        success: function (data1, textStatus, xhr) {
                                            $.each( data1, function( key2,val2 ) {
                                                if ((val2.evenement== idEvent) && (val2.id > maxSlot)){
                                                    maxSlot = val2.id;
                                                }
                                                
                                            });
                                            $.ajax({
                                                url: '/soutenances/api/Soutenances/',
                                                type: 'POST',
                                                dataType: 'json',
                                                data: { csrfmiddlewaretoken : csrftoken,
                                                slot: maxSlot,
                                                groupeSoutenance: resSelectGroupe,
                                                },
                                                success: function (data, textStatus, xhr) {

                                                },
                                                error: function (xhr, textStatus, errorThrown) {
                                                    console.log('Error in Operation');
                                                }
                                            });
                                            
                                            
                                            


                                        },
                                        error: function (xhr, textStatus, errorThrown) {
                                            console.log('Error in Operation');
                                        }
                                    });
                                    
                                    
                                }
                                }
                            });
                    }
                });
                
                
            },
            error: function (xhr, textStatus, errorThrown) {
                console.log('Error in Operation');
            }
        });


    });
        
       
});
</script>

{% else %}
<div class="alert alert-danger" role="alert">
  Vous <strong>n'avez pas accès</strong> à cette page !
</div>
{% endif %}
{% endblock %}
